<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:news="http://www.dotnetnuke.com/modules/news" xmlns:newsext="urn:NewsExtensions">
 <xsl:output method="html" indent="yes"/>
 <xsl:param name="ItemsToShow"/>
 <xsl:param name="ShowItemDetails"/>
 <xsl:param name="ShowItemDate"/>
 <xsl:param name="Locale"/>
 <xsl:param name="Target"/>
 <xsl:template match="rss">
  <script>
    $(document).ready(function() {
      $('.normal').addClass('container');

      function shorten(text, maxLength) {
      	var ret = text;
		if (ret.length > maxLength) {
	    	ret = ret.substr(0,maxLength-3) + "…";
	    }
	    
	    return ret;
      }


      $('.newsContainer').each(function(index, el) {
      	var description = $(this).children('.description_wrapper').children();

      	
      	var img = $(description[0]).find('img');
      	var img_wrap = $(this).find('.feedImage_wrapper');

      	img.detach().appendTo(img_wrap);
      	description.text(shorten(description.text(), 150)); 
      })


      $('.newsSlider').not('.slick-initialized').each(function(index, el) {
      	$(this).slick({
      	    dots: false,
      	    speed: 300,
      	    infinite: false,
      	    slidesToShow: 3,
      	    slidesToScroll: 3,
      	    responsive: [
      	        {
      	            breakpoint: 1024,
      	            settings: {
      	                slidesToShow: 2,
      	                slidesToScroll: 2
      	            }
      	        },
      	        {
      	            breakpoint: 700,
      	            settings: {
      	                slidesToShow: 1,
      	                slidesToScroll: 1,
      	                arrows: false,
      	                dots: true
      	            }
      	        }
      	        // You can unslick at a given breakpoint now by adding:
      	        // settings: "unslick"
      	        // instead of a settings object
      	    ]
      	});	
      });
      // $('.newsSlider').slick({
      //     dots: false,
      //     speed: 300,
      //     infinite: false,
      //     slidesToShow: 3,
      //     slidesToScroll: 3,
      //     responsive: [
      //         {
      //             breakpoint: 1024,
      //             settings: {
      //                 slidesToShow: 2,
      //                 slidesToScroll: 2
      //             }
      //         },
      //         {
      //             breakpoint: 700,
      //             settings: {
      //                 slidesToShow: 1,
      //                 slidesToScroll: 1,
      //                 arrows: false,
      //                 dots: true
      //             }
      //         }
      //         // You can unslick at a given breakpoint now by adding:
      //         // settings: "unslick"
      //         // instead of a settings object
      //     ]
      // });

      
      $('.slick-list').addClass('container');
    });
  </script>
  <div class="newsSlider clearfix">
    <xsl:for-each select="channel/item[position()&lt;=$ItemsToShow or $ItemsToShow&lt;1]">
    <xsl:sort data-type="text" select="news:pubDateParsed" order="descending" />

    <div class="col-xs-12 col-sm-6 col-lg-3 newsContainer">
      <div>
        <a href="{link}">
        	<div class="feedImage_wrapper">
        	</div>
            <!--<img class="feedImage" src="/Portals/0/logo.png?ver=2017-04-06-112827-477" alt=""/> -->
        </a>
      </div>
      <div class="newsContainerHeader">
        <span>APSA NEWS</span>
        <a href="{link}">
          <h4><xsl:value-of select="title"/></h4>
        </a>
      </div>
      <div class="description_wrapper">
        <xsl:if test="$ShowItemDetails='true'">
         <p class="Normal">
          <xsl:value-of select="description" disable-output-escaping="yes"/>
         </p>
        </xsl:if>
      </div>

   <!-- <h4>
    <a href="{link}">
     <xsl:attribute name="target"><xsl:value-of select="$Target"/></xsl:attribute>
     <xsl:value-of select="title"/>
    </a>
   </h4>
   <xsl:if test="$ShowItemDate='true'">
    <h6>
     <xsl:value-of select="newsext:FormatDateTimeFromString(news:pubDateParsed, 'D')" />
    </h6>
   </xsl:if>
   -->


   </div> 
  </xsl:for-each>
  </div>
  
 </xsl:template>
</xsl:stylesheet>
